



/*
* Copyright (C) 2009 Bosch Sensortec GmbH
*
*	BMA150 linux driver
* 
* Usage:	BMA150 driver by i2c for linux
*
* 
 */
/*
 * This software program is licensed subject to the GNU General Public License
 * (GPL).Version 2,June 1991, available at http://www.fsf.org/copyleft/gpl.html

 * (C) Copyright 2008 Bosch Sensortec GmbH
 * All Rights Reserved
 *
 

Disclaimer 

 * Common:
 * This Work is developed for the consumer goods industry. It may only be used 
 * within the parameters of the respective valid product data sheet.  The Work 
 * provided with the express understanding that there is no warranty of fitness for a particular purpose. 
 * It is not fit for use in life-sustaining, safety or security sensitive systems or any system or device 
 * that may lead to bodily harm or property damage if the system or device malfunctions. In addition, 
 * the Work is not fit for use in products which interact with motor vehicle systems.  
 * The resale and/or use of the Work are at the purchasers own risk and his own responsibility. The 
 * examination of fitness for the intended use is the sole responsibility of the Purchaser. 
 *
 * The purchaser shall indemnify Bosch Sensortec from all third party claims, including any claims for 
 * incidental, or consequential damages, arising from any Work or Derivative Work use not covered by the parameters of 
 * the respective valid product data sheet or not approved by Bosch Sensortec and reimburse Bosch 
 * Sensortec for all costs in connection with such claims.
 *
 * The purchaser must monitor the market for the purchased Work and Derivative Works, particularly with regard to 
 * product safety and inform Bosch Sensortec without delay of all security relevant incidents.
 *
 * Engineering Samples are marked with an asterisk (*) or (e). Samples may vary from the valid 
 * technical specifications of the product series. They are therefore not intended or fit for resale to third 
 * parties or for use in end products. Their sole purpose is internal client testing. The testing of an 
 * engineering sample may in no way replace the testing of a product series. Bosch Sensortec 
 * assumes no liability for the use of engineering samples. By accepting the engineering samples, the 
 * Purchaser agrees to indemnify Bosch Sensortec from all claims arising from the use of engineering 
 * samples.
 *
 * Special:
 * This Work and any related information (hereinafter called "Information") is provided free of charge 
 * for the sole purpose to support your application work. The Woek and Information is subject to the 
 * following terms and conditions: 
 *
 * The Work is specifically designed for the exclusive use for Bosch Sensortec products by 
 * personnel who have special experience and training. Do not use this Work or Derivative Works if you do not have the 
 * proper experience or training. Do not use this Work or Derivative Works fot other products than Bosch Sensortec products.  
 *
 * The Information provided is believed to be accurate and reliable. Bosch Sensortec assumes no 
 * responsibility for the consequences of use of such Information nor for any infringement of patents or 
 * other rights of third parties which may result from its use. No license is granted by implication or 
 * otherwise under any patent or patent rights of Bosch. Specifications mentioned in the Information are 
 * subject to change without notice.
 *
 */

/**********************************************************************
* Modified by
* (C) NEC CASIO Mobile Communications, Ltd. 2011
**********************************************************************/








#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/fs.h>
#include <linux/slab.h>
#include <linux/init.h>
#include <linux/list.h>
#include <linux/i2c.h>



#include <asm/uaccess.h>
#include <linux/unistd.h>
#include <linux/delay.h>
#include <linux/miscdevice.h>





#include <linux/kthread.h>
#include <linux/spinlock.h>

#include <linux/i2c/bma150_driver.h>

#include <linux/i2c/smb380.h>
#include <linux/i2c/BMA150calib.h>








































































#define DEBUG_PRINT( arg... )





#define DEBUG_PRINT2( arg... )


#define D_BMA150_CALIB_DATA_WRITE_TO_EEPROM	(1)

#define D_BMA150_AFTER_RESET_WAIT_MS		(4)		
#define D_BMA150_AFTER_RESET_WAIT_US		(10)	


#define D_BMA150_STATE_CHANGE_WAIT_MS		(50)	


#define D_BMA150_WAIT_AFTER_SLEEP_NG		(0)
#define D_BMA150_WAIT_AFTER_SLEEP_OK		(1)


#define D_BMA150_ACCEL_DATA_NOT_READY		(0)
#define D_BMA150_ACCEL_DATA_READY			(1)


#define D_BMA150_DIAG_SET_FALSE				(0)
#define D_BMA150_DIAG_SET_TRUE				(1)


#define D_BMA150_RET_OK						(0)


#define D_BMA150_RANGE_BIT1					(1 << 1)
#define D_BMA150_RANGE_BIT0					(1 << 0)
#define D_BMA150_RANGE_BIT					(D_BMA150_RANGE_BIT1 | D_BMA150_RANGE_BIT0)


#define D_BMA150_BANDWIDTH_BIT2				(1 << 2)
#define D_BMA150_BANDWIDTH_BIT1				(1 << 1)
#define D_BMA150_BANDWIDTH_BIT0				(1 << 0)
#define D_BMA150_BANDWIDTH_BIT				(D_BMA150_BANDWIDTH_BIT2 | D_BMA150_BANDWIDTH_BIT1 | D_BMA150_BANDWIDTH_BIT0)


#define D_BMA150_CTRL_REG_RSVD_BIT0			(1 << 0)
#define D_BMA150_CTRL_REG_RSVD_BIT			(D_BMA150_CTRL_REG_RSVD_BIT0)

#define D_BMA150_RANGE_BWIDTH_REG_RSVD_BIT2	(1 << 2)
#define D_BMA150_RANGE_BWIDTH_REG_RSVD_BIT1	(1 << 1)
#define D_BMA150_RANGE_BWIDTH_REG_RSVD_BIT0	(1 << 0)
#define D_BMA150_RANGE_BWIDTH_REG_RSVD_BIT	(D_BMA150_RANGE_BWIDTH_REG_RSVD_BIT2 | D_BMA150_RANGE_BWIDTH_REG_RSVD_BIT1 | D_BMA150_RANGE_BWIDTH_REG_RSVD_BIT0)

#define D_BMA150_SPI_BIT0					(1 << 0)
#define D_BMA150_CTRL_REG_RSVD_BIT			(D_BMA150_CTRL_REG_RSVD_BIT0)



#define D_BMA150_RD_ADDR_OPREG_MIN			(0x00)
#define D_BMA150_RD_ADDR_OPREG_MAX			(0x15)

#define D_BMA150_RD_ADDR_DSREG_MIN			(0x16)
#define D_BMA150_RD_ADDR_DSREG_MAX			(0x22)



#define D_BMA150_WR_ADDR_OPREG_MIN			(0x0A)
#define D_BMA150_WR_ADDR_OPREG_MAX			(0x15)

#define D_BMA150_WR_ADDR_DSREG_IMG_MIN		(0x16)
#define D_BMA150_WR_ADDR_DSREG_IMG_MAX		(0x1D)

#define D_BMA150_WR_ADDR_DSREG_E2P_MIN		(0x2B)
#define D_BMA150_WR_ADDR_DSREG_E2P_MAX		(0x3D)

static smb380acc_t g_offset = {0, 0, 0};
static struct i2c_client *bma150_client = NULL;

static smb380acc_t g_accel_data = {0, 0, 0};
static spinlock_t g_accel_data_spin_lock;

static unsigned char     g_range               = SMB380_RANGE_8G;
static int               g_open_count          = 0;
static int               g_is_wait_after_sleep = D_BMA150_WAIT_AFTER_SLEEP_OK;
static int               g_is_ready_accel_data = D_BMA150_ACCEL_DATA_NOT_READY;
static int               g_diag_mode           = D_BMA150_DIAG_MODE_OFF;
static int               g_is_diag_set         = D_BMA150_DIAG_SET_FALSE;
static unsigned long     g_measurement_cycle   = 200;

static wait_queue_head_t g_open_count_queue;
static wait_queue_head_t g_wait_after_sleep_queue;
static wait_queue_head_t g_diag_mode_queue;
static wait_queue_head_t g_diag_set_queue;

struct bma150_data{
	smb380_t smb380;
};





static int bma150_i2c_write(unsigned char reg_addr, unsigned char *data, unsigned char len);
static int bma150_i2c_read(unsigned char reg_addr, unsigned char *data, unsigned char len);

static void bma150_i2c_delay(unsigned int msec);


static int bma150_i2c_tx_data(char *p_txData, int length)
{
	int            ret   = 0;
	struct i2c_msg msg[] =
	{
		{
			.addr  = bma150_client->addr,
			.flags = 0,
			.len   = length,
			.buf   = p_txData,
		},
	};

	if (i2c_transfer(bma150_client->adapter, msg, 1) < 0)
	{
		printk( KERN_ERR "%s: transfer error.\n", __func__ );
		ret = -1;
	}

	return ret;
}

static int bma150_i2c_rx_data(char *p_rxData, int length)
{
	int            ret    = 0;
	struct i2c_msg msgs[] =
	{
		{
			.addr  = bma150_client->addr,
			.flags = 0,
			.len   = 1,
			.buf   = p_rxData,
		},
		{
			.addr  = bma150_client->addr,
			.flags = I2C_M_RD,
			.len   = length,
			.buf   = p_rxData,
		},
	};

	DEBUG_PRINT2( "%s: rxData(0x%08X) rxData[0](%08X) rxData[1](%08X) length(%d) slave_addr(0x%02X)\n"
	              , __func__, (unsigned int)p_rxData, p_rxData[0], p_rxData[1], length, bma150_client->addr );

	if (i2c_transfer(bma150_client->adapter, msgs, 2) < 0)
	{
		printk( KERN_ERR "%s: transfer error.\n", __func__ );
		ret = -1;
	}

	DEBUG_PRINT2( "%s: rxData[0](%08X) rxData[1](%08X) length(%d) slave_addr(0x%02X)\n", __func__, p_rxData[0], p_rxData[1], length, bma150_client->addr );

	return ret;
}



static inline void bma150_i2c_delay(unsigned int msec)
{
	mdelay(msec);
}





static inline int bma150_i2c_write(unsigned char reg_addr, unsigned char *data, unsigned char len)

{
	s32 dummy;

	unsigned char buffer[2];

	if( bma150_client == NULL )	
		return -1;

	while(len--)
	{



		buffer[0] = reg_addr;
		buffer[1] = *data;



		dummy = bma150_i2c_tx_data( (char*)buffer, 2 );


		reg_addr++;
		data++;
		if(dummy < 0)
			return -1;
	}
	return 0;
}





static inline int bma150_i2c_read(unsigned char reg_addr, unsigned char *data, unsigned char len) 

{
	s32 dummy;
	if( bma150_client == NULL )	
		return -1;

	while(len--)
	{        














		*data = reg_addr;
		dummy = bma150_i2c_rx_data( (char*)data, 1 );
		if(dummy < 0)
			return -1;


		reg_addr++;
		data++;
	}
	return 0;
}

























































static ssize_t bma150_read(struct file *file, char __user *buf, size_t count, loff_t *offset)
{	
	smb380acc_t acc;	
	int ret;
	if( bma150_client == NULL )
	{
		printk(KERN_ERR "I2C driver not install\n");
		return -1;
	}

	smb380_read_accel_xyz(&acc);


	printk(KERN_INFO "BMA150: X/Y/Z axis: %-8d %-8d %-8d\n" ,
		(int)acc.x, (int)acc.y, (int)acc.z);  


	if( count != sizeof(acc) )
	{
		return -1;
	}
	ret = copy_to_user(buf,&acc, sizeof(acc));
	if( ret != 0 )
	{
		DEBUG_PRINT( "BMA150: copy_to_user result: %d\n", ret );
	}
	return sizeof(acc);
}


static ssize_t bma150_write(struct file *file, const char __user *buf, size_t count, loff_t *offset)
{
	if( bma150_client == NULL )
		return -1;

	DEBUG_PRINT( "BMA150 should be accessed with ioctl command\n" );
	return 0;
}


static int bma150_open(struct inode *inode, struct file *file)
{
	DEBUG_PRINT( "%s: start.\n", __func__ );

	if( bma150_client == NULL)
	{
		printk(KERN_ERR "I2C driver not install\n"); 
		return -1;
	}






	spin_lock( &g_accel_data_spin_lock );
	g_open_count++;
	spin_unlock( &g_accel_data_spin_lock );
	
	
	wake_up( &g_open_count_queue );

	DEBUG_PRINT( "%s: end. open_count(%d)\n", __func__, g_open_count );
	return 0;
}


static int bma150_close(struct inode *inode, struct file *file)
{
	DEBUG_PRINT( "%s: start.\n", __func__ );

	spin_lock( &g_accel_data_spin_lock );

	if( g_open_count <= 0 )
	{
		g_open_count = 0;
	}
	else
	{
		g_open_count--;
	}

	spin_unlock( &g_accel_data_spin_lock );

	DEBUG_PRINT( "%s: end. open_count(%d)\n", __func__, g_open_count );

	return 0;
}

static int bma150_range_data_check( unsigned char range )
{
	int ret = (-1);

	switch( range )
	{
		case SMB380_RANGE_2G:
		case SMB380_RANGE_4G:
		case SMB380_RANGE_8G:
			ret = 0;
			break;
		default:
			printk( KERN_ERR "%s: range_value(%02X) error\n", __func__, range );
			ret = -EINVAL;
			break;
	}

	return ret;
}

static int bma150_bandwidth_data_check( unsigned char bandwidth )
{
	int ret = (-1);

	switch( bandwidth )
	{
		case SMB380_BW_25HZ:
		case SMB380_BW_50HZ:
		case SMB380_BW_100HZ:
		case SMB380_BW_190HZ:
		case SMB380_BW_375HZ:
		case SMB380_BW_750HZ:
		case SMB380_BW_1500HZ:
			ret = 0;
			break;
		default:
			printk( KERN_ERR "%s: bandwidth_value(%02X) error\n", __func__, bandwidth );
			ret = -EINVAL;
			break;
	}

	return ret;
}

static void bma150_update_drv_range( unsigned char address )
{
	int ret                   = (-1);
	unsigned char range_value = 0x00;

	if(    (address == SMB380_RANGE_BWIDTH_REG)															
	    || ((D_BMA150_WR_ADDR_DSREG_E2P_MIN <= address) && (address <= D_BMA150_WR_ADDR_DSREG_E2P_MAX))	
	  )
	{
		
		ret = smb380_get_range( &range_value );
		if( ret == 0 )
		{
			spin_lock( &g_accel_data_spin_lock );
			g_range = range_value;
			spin_unlock( &g_accel_data_spin_lock );
			DEBUG_PRINT( "%s: range(%02X) set\n", __func__, g_range );
		}
		else
		{
			printk( KERN_ERR "%s: smb380_get_range err(%d)\n", __func__, ret );
		}
	}

	return;
}

static int bma150_write_data_check( unsigned char address, unsigned char data )
{
	int           ret                = 0;
	unsigned char range_value        = 0x00;
	unsigned char bandwidth_value    = 0x00;
	unsigned char reserved_value     = 0x00;
	unsigned char now_reserved_value = 0x00;
	unsigned char spi_value          = 0x00;
	unsigned char get_data = 0x00;

	if( address == SMB380_CTRL_REG )															
	{
		reserved_value = (data & SMB380_CTRL_REG_RSVD__MSK) >> SMB380_CTRL_REG_RSVD__POS;
		DEBUG_PRINT( "%s: address(%02X), reserved_value(%02X)\n", __func__, address, reserved_value );

		
		if( reserved_value == D_BMA150_CTRL_REG_RSVD_BIT )
		{
			printk( KERN_ERR "%s: address(%02X) reserved_value(%02X) error\n", __func__, address, reserved_value );
			ret = -EINVAL;
		}
	}
	else if( (address | SMB380_EEP_OFFSET) == (SMB380_RANGE_BWIDTH_REG | SMB380_EEP_OFFSET) )	
	{
		
		range_value     = (data & SMB380_RANGE__MSK)                 >> SMB380_RANGE__POS;
		bandwidth_value = (data & SMB380_BANDWIDTH__MSK)             >> SMB380_BANDWIDTH__POS;
		reserved_value  = (data & SMB380_RANGE_BWIDTH_REG_RSVD__MSK) >> SMB380_RANGE_BWIDTH_REG_RSVD__POS;
		DEBUG_PRINT( "%s: range(%02X), bandwidth(%02X) reserved(%02X)\n", __func__, range_value, bandwidth_value, reserved_value );

		ret = smb380_read_reg((address & ~(SMB380_EEP_OFFSET)), &get_data, 1);
		if( ret != 0 )
		{
			printk( KERN_ERR "%s: smb380_read_reg error\n", __func__ );
			return -EIO;
		}
		now_reserved_value = (get_data & SMB380_RANGE_BWIDTH_REG_RSVD__MSK) >> SMB380_RANGE_BWIDTH_REG_RSVD__POS;

		if(    (range_value     == D_BMA150_RANGE_BIT)											
		    || (bandwidth_value == D_BMA150_BANDWIDTH_BIT)										
		    || (reserved_value  != now_reserved_value)											
		  )
		{
			printk( KERN_ERR "%s: range(%02X) or bandwidth(%02X) or reserved(%02X)!=now_reserved(%02X) error\n", __func__, range_value, bandwidth_value, reserved_value, now_reserved_value );
			ret = -EINVAL;
		}
	}
	else if( (address | SMB380_EEP_OFFSET) == (SMB380_CONF2_REG | SMB380_EEP_OFFSET) )			
	{
		spi_value = (data & SMB380_SPI4__MSK) >> SMB380_SPI4__POS;
		DEBUG_PRINT( "%s: address(%02X), spi_value(%02X)\n", __func__, address, spi_value );

		
		if( spi_value == SMB380_SMB380_SPI4_OFF )
		{
			printk( KERN_ERR "%s: address(%02X) spi_value(%02X) error\n", __func__, address, spi_value );
			ret = -EINVAL;
		}
	}
	else
	{
		
	}

	return ret;
}


static int bma150_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg)
{
	int err = 0;
	unsigned char data[6];





	unsigned char write_address         = 0x00;
	unsigned char write_data            = 0x00;
	unsigned long tmp_measurement_cycle = 0;
	long          wait_ret              = 0;







	
	if(_IOC_TYPE(cmd) != BMA150_IOC_MAGIC)	
	{
		printk(KERN_ERR "cmd magic type error\n");
		return -ENOTTY;
	}
	if(_IOC_NR(cmd) > BMA150_IOC_MAXNR)
	{
		printk(KERN_ERR "cmd number error\n");
		return -ENOTTY;
	}

	if(_IOC_DIR(cmd) & _IOC_READ)
		err = !access_ok(VERIFY_WRITE,(void __user*)arg, _IOC_SIZE(cmd));
	else if(_IOC_DIR(cmd) & _IOC_WRITE)
		err = !access_ok(VERIFY_READ, (void __user*)arg, _IOC_SIZE(cmd));
	if(err)
	{
		printk(KERN_ERR "cmd access_ok error\n");
		return -EFAULT;
	}
	
	if( bma150_client == NULL)
	{
		printk(KERN_ERR "I2C driver not install\n"); 
		return -EFAULT;
	}

	
	wait_ret = wait_event_timeout( g_wait_after_sleep_queue, g_is_wait_after_sleep == D_BMA150_WAIT_AFTER_SLEEP_OK, (HZ / 5) );
	if( wait_ret == 0 )
	{
		
		printk( KERN_ERR "%s:  timeout\n", __func__ );
		return -ETIME;
	}

	
	switch(cmd)
	{
	case BMA150_SOFT_RESET:
		err = smb380_soft_reset();
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_SOFT_RESET: set soft_reset error\n", __func__ );
			err = -EIO;
			break;
		}

		
		mdelay( D_BMA150_AFTER_RESET_WAIT_MS );
		udelay( D_BMA150_AFTER_RESET_WAIT_US );

		
		err = smb380_set_bandwidth( SMB380_BW_50HZ );
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_SOFT_RESET: set bandwidth error\n", __func__ );
			err = -EIO;
			break;
		}

		
		err = smb380_set_range( SMB380_RANGE_8G );
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_SOFT_RESET: set range error\n", __func__ );
			err = -EIO;
		}
		else
		{
			spin_lock( &g_accel_data_spin_lock );
			g_range = SMB380_RANGE_8G;
			spin_unlock( &g_accel_data_spin_lock );
			DEBUG_PRINT( "%s: BMA150_SOFT_RESET: range(%02X) set\n", __func__, g_range );
		}
		break;

	case BMA150_SET_RANGE:
		if(copy_from_user(data,(unsigned char*)arg,1)!=0)
		{
			printk(KERN_ERR "copy_from_user error\n");
			err = -EFAULT;
			break;
		}

		err = bma150_range_data_check( data[0] );
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_SET_RANGE: bma150_range_data_check error\n", __func__ );
			break;
		}

		err = smb380_set_range(data[0]);

		if( err == 0 )
		{
			spin_lock( &g_accel_data_spin_lock );
			g_range = data[0];
			spin_unlock( &g_accel_data_spin_lock );
			DEBUG_PRINT( "%s: BMA150_SET_RANGE: range(%02X) set\n", __func__, g_range );
		}
		else
		{
			printk( KERN_ERR "%s: BMA150_SET_RANGE: smb380_set_range error\n", __func__ );
			err = -EIO;
		}

		break;

	case BMA150_GET_RANGE:
		err = smb380_get_range(data);
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_GET_RANGE: smb380_get_range error\n", __func__ );
			err = -EIO;
			break;
		}

		if(copy_to_user((unsigned char*)arg,data,1)!=0)
		{
			printk(KERN_ERR "copy_to_user error\n");
			err = -EFAULT;
		}
		break;

	case BMA150_GET_RANGE_DRV_DATA:
		spin_lock( &g_accel_data_spin_lock );
		data[0] = g_range;
		spin_unlock( &g_accel_data_spin_lock );
		DEBUG_PRINT( "%s: BMA150_GET_RANGE_DRV_DATA: range(%02X) out\n", __func__, data[0] );

		if(copy_to_user((unsigned char*)arg,data,1)!=0)
		{
			printk(KERN_ERR "copy_to_user error\n");
			err = -EFAULT;
		}
		break;






















	case BMA150_SET_BANDWIDTH:
		if(copy_from_user(data,(unsigned char*)arg,1)!=0)
		{
			printk(KERN_ERR "copy_from_user error\n");
			err = -EFAULT;
			break;
		}

		err = bma150_bandwidth_data_check( data[0] );
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_SET_BANDWIDTH: bma150_bandwidth_data_check error\n", __func__ );
			break;
		}

		err = smb380_set_bandwidth(data[0]);
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_SET_BANDWIDTH: smb380_set_bandwidth error\n", __func__ );
			err = -EIO;
		}

		break;

	case BMA150_GET_BANDWIDTH:
		err = smb380_get_bandwidth(data);
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_GET_BANDWIDTH: smb380_get_bandwidth error\n", __func__ );
			err = -EIO;
			break;
		}

		if(copy_to_user((unsigned char*)arg,data,1)!=0)
		{
			printk(KERN_ERR "copy_to_user error\n");
			err = -EFAULT;
		}
		break;
































































































































































































































	case BMA150_GET_INTERRUPT_STATUS:
		err = smb380_get_interrupt_status(data);
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_GET_INTERRUPT_STATUS: smb380_get_interrupt_status error\n", __func__ );
			err = -EIO;
			break;
		}

		if(copy_to_user((unsigned char*)arg,data,1)!=0)
		{
			printk(KERN_ERR "copy_to_user error\n");
			err = -EFAULT;
		}
		break;














































































































	case BMA150_READ_ACCEL_XYZ:
		err = smb380_read_accel_xyz((smb380acc_t*)data);
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_READ_ACCEL_XYZ: smb380_read_accel_xyz error\n", __func__ );
			err = -EIO;
			break;
		}

		if(copy_to_user((smb380acc_t*)arg,(smb380acc_t*)data,6)!=0)
		{
			printk(KERN_ERR "copy_to error\n");
			err = -EFAULT;
		}
		DEBUG_PRINT( "%s: BMA150_READ_ACCEL_XYZ: x(%d), y(%d), z(%d)\n", __func__, (*((smb380acc_t*)data)).x, (*((smb380acc_t*)data)).y, (*((smb380acc_t*)data)).z );
		break;

	case BMA150_READ_ACCEL_XYZ_DRV_DATA:
		spin_lock( &g_accel_data_spin_lock );
		if( g_is_ready_accel_data == D_BMA150_ACCEL_DATA_NOT_READY )
		{
			spin_unlock( &g_accel_data_spin_lock );
			DEBUG_PRINT( "%s: BMA150_READ_ACCEL_XYZ_DRV_DATA: poll_thread is NON_ACTIVE_STATE yet\n", __func__ );
			err = -EAGAIN;
			break;
		}
		else
		{
			memcpy( data, &g_accel_data, sizeof(smb380acc_t) );
			spin_unlock( &g_accel_data_spin_lock );
		}

		if(copy_to_user((smb380acc_t*)arg,(smb380acc_t*)data,6)!=0)
		{
			printk(KERN_ERR "copy_to error\n");
			err = -EFAULT;
		}
		else
		{
			DEBUG_PRINT( "%s: BMA150_READ_ACCEL_XYZ_DRV_DATA: x(%d), y(%d), z(%d)\n", __func__, (*((smb380acc_t*)data)).x, (*((smb380acc_t*)data)).y, (*((smb380acc_t*)data)).z );
			err = D_BMA150_RET_OK;
		}
		break;

	case BMA150_READ_TEMPERATURE:
		err = smb380_read_temperature(data);
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_READ_TEMPERATURE: smb380_read_temperature error\n", __func__ );
			err = -EIO;
			break;
		}

		if(copy_to_user((unsigned char*)arg,data,1)!=0)
		{
			printk(KERN_ERR "copy_to_user error\n");
			err = -EFAULT;
		}
		DEBUG_PRINT( "%s: BMA150_READ_TEMPERATURE: value(%02X)\n", __func__, data[0] );
		break;

	
	case BMA150_CALIBRATION:
		if(copy_from_user((smb380acc_t*)data,(smb380acc_t*)arg,6)!=0)
		{
			printk(KERN_ERR "copy_from_user error\n");
			err = -EFAULT;
			break;
		}

		err = bma150_calibrate(*(smb380acc_t*)data, (smb380acc_t*)&g_offset);
		
		
		if((err & CALIB_ERR_MOV) == CALIB_ERR_MOV)
		{
			DEBUG_PRINT( "Calibration aborted, Movement detected:[0x%04x]\n", err );
			err = -EIO;
			break;
		}
		if((err & NO_CALIB) == NO_CALIB)
		{
			DEBUG_PRINT( "No calibration needed at all:[0x%04x]\n", err );
			DEBUG_PRINT( "x, y, z:[%d, %d, %d]\n", g_offset.x, g_offset.y, g_offset.z );
			err = D_BMA150_RET_OK;
			break;
		}
		if(err == NO_ERR)
		{
			
			
			err = bma150_writeCalib(&g_offset, D_BMA150_CALIB_DATA_WRITE_TO_EEPROM);
			if( err != 0 )
			{
				err = -EIO;
				printk( KERN_ERR "%s: BMA150_CALIBRATION: bma150_writeCalib error\n", __func__ );
			}
		}
		break;

	case BMA150_SET_EE_W:
		if(copy_from_user(data,(unsigned char*)arg,1)!=0)
		{
			printk(KERN_ERR "copy_from_user error\n");
			err = -EFAULT;
			break;
		}

		if( (data[0] != SMB380_EE_W_OFF) && (data[0] != SMB380_EE_W_ON) )
		{
			printk( KERN_ERR "%s: BMA150_WRITE_EE: ee_w_value(%02X) error\n", __func__, data[0] );
			err = -EINVAL;
			break;
		}
		err = smb380_set_ee_w( data[0] );
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_SET_EE_W: smb380_set_ee_w error\n", __func__ );
			err = -EIO;
			break;
		}

		break;

	case BMA150_WRITE_EE:
		if(copy_from_user(data,(unsigned char*)arg,2)!=0)
		{
			printk(KERN_ERR "copy_from_user error\n");
			err = -EFAULT;
			break;
		}
		write_address = data[0];
		write_data    = data[1];
		DEBUG_PRINT( "%s: BMA150_WRITE_EE: address(%02X), data(%02X)\n", __func__, write_address, write_data );

		
		if(    (write_address                  < D_BMA150_WR_ADDR_DSREG_E2P_MIN)
		    || (D_BMA150_WR_ADDR_DSREG_E2P_MAX < write_address)
		  )
		{
			printk( KERN_ERR "%s: BMA150_WRITE_EE: write_address(%02X) error\n", __func__, data[0] );
			err = -EFAULT;
			break;
		}

		
		err = bma150_write_data_check( write_address, write_data );
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_WRITE_EE: write data error\n", __func__ );
			break;
		}

		err = smb380_write_ee(write_address, write_data);
		if( err == 0 )
		{
			bma150_update_drv_range( write_address );
		}
		else
		{
			err = -EIO;
			printk( KERN_ERR "%s: BMA150_WRITE_EE: smb380_write_ee error\n", __func__ );
		}
		break;

	case BMA150_READ_REG:
		if(copy_from_user(data,(unsigned char*)arg,2)!=0)
		{
			printk(KERN_ERR "copy_from_user error\n");
			err = -EFAULT;
			break;
		}

		



		if(D_BMA150_RD_ADDR_DSREG_MAX < data[0])

		{
			printk( KERN_ERR "%s: BMA150_READ_REG: read_address(%02X) error\n", __func__, data[0] );
			err = -EFAULT;
			break;
		}

		err = smb380_read_reg(data[0], &data[1], 1);
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_READ_REG: smb380_read_reg error\n", __func__ );
			err = -EIO;
			break;
		}
		DEBUG_PRINT( "%s: BMA150_READ_REG: address(%02X), data(%02X)\n", __func__, data[0], data[1] );

		if(copy_to_user((unsigned char*)arg,data,2)!=0)
		{
			printk(KERN_ERR "copy_to_user error\n");
			err = -EFAULT;
		}
		break;

	case BMA150_WRITE_REG:
		if(copy_from_user(data,(unsigned char*)arg,2)!=0)
		{
			printk(KERN_ERR "copy_from_user error\n");
			err = -EFAULT;
			break;
		}
		write_address = data[0];
		write_data    = data[1];

		DEBUG_PRINT( "%s: BMA150_WRITE_REG: address(%02X), data(%02X)\n", __func__, data[0], data[1] );

		
		if( (write_address < D_BMA150_WR_ADDR_OPREG_MIN) || (D_BMA150_WR_ADDR_DSREG_IMG_MAX < write_address) )
		{
			printk( KERN_ERR "%s: BMA150_WRITE_REG: write_address(%02X) error\n", __func__, data[0] );
			err = -EFAULT;
			break;
		}

		
		err = bma150_write_data_check( write_address, write_data );
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_WRITE_REG: write data error\n", __func__ );
			break;
		}

		err = smb380_write_reg(write_address, &write_data, 1);
		if( err == 0 )
		{
			bma150_update_drv_range( write_address );
		}
		else
		{
			printk( KERN_ERR "%s: BMA150_WRITE_REG: smb380_write_reg error\n", __func__ );
			err = -EIO;
		}
		break;

	case BMA150_SELFTEST:
		if(copy_from_user(data,(unsigned char*)arg,1)!=0)
		{
			printk(KERN_ERR "copy_from_user error\n");
			err = -EFAULT;
			break;
		}

		if( (data[0] != SMB380_SELF_TEST0_ON) && (data[0] != SMB380_SELF_TEST1_ON) )
		{
			printk( KERN_ERR "%s: BMA150_SELFTEST: self_test_value(%02X) error\n", __func__, data[0] );
			err = -EINVAL;
			break;
		}

		err = smb380_selftest(data[0]);
		if( err != 0 )
		{
			printk( KERN_ERR "%s: BMA150_SELFTEST: smb380_selftest error\n", __func__ );
			err = -EIO;
		}
		break;

	case BMA150_SET_MEASUREMENT_CYCLE:
		if(copy_from_user((unsigned long*)data,(unsigned long*)arg,4)!=0)
		{
			printk(KERN_ERR "copy_from_user error\n");
			err = -EFAULT;
			break;
		}

		tmp_measurement_cycle = *(unsigned long*)data;

		spin_lock( &g_accel_data_spin_lock );
		if( tmp_measurement_cycle <= 10 )
		{
			g_measurement_cycle = 10;
		}
		else
		{
			g_measurement_cycle = tmp_measurement_cycle;
		}
		spin_unlock( &g_accel_data_spin_lock );
		DEBUG_PRINT( "%s: BMA150_SET_MEASUREMENT_CYCLE: cycle(%lu) tmp_cycle(%lu) set\n", __func__, g_measurement_cycle, tmp_measurement_cycle );
		err = D_BMA150_RET_OK;
		break;

	case BMA150_SET_DIAG_MODE:
		if(copy_from_user(data,(unsigned char*)arg,1)!=0)
		{
			printk(KERN_ERR "copy_from_user error\n");
			err = -EFAULT;
			break;
		}

		if( (data[0] != D_BMA150_DIAG_MODE_OFF) && (data[0] != D_BMA150_DIAG_MODE_ON) )
		{
			printk( KERN_ERR "%s: BMA150_SET_DIAG_MODE: parameter(%02X) error\n", __func__, data[0] );
			err = -EINVAL;
			break;
		}

		spin_lock( &g_accel_data_spin_lock );
		g_diag_mode = data[0];
		spin_unlock( &g_accel_data_spin_lock );
		DEBUG_PRINT( "%s: BMA150_SET_DIAG_MODE: diag_mode(%02X) set\n", __func__, g_diag_mode );

		if( g_diag_mode == D_BMA150_DIAG_MODE_OFF )
		{
			
			wake_up( &g_diag_mode_queue );
			err = D_BMA150_RET_OK;
		}
		else
		{
			
			wait_ret = wait_event_timeout( g_diag_set_queue, g_is_diag_set == D_BMA150_DIAG_SET_TRUE, HZ );
			if( wait_ret == 0 )
			{
				
				spin_lock( &g_accel_data_spin_lock );
				g_diag_mode = D_BMA150_DIAG_MODE_OFF;
				spin_unlock( &g_accel_data_spin_lock );
				printk( KERN_ERR "%s: BMA150_SET_DIAG_MODE: diag_set timeout\n", __func__ );
				err = -ETIME;
			}
			else
			{
				DEBUG_PRINT( "%s: BMA150_SET_DIAG_MODE: diag_set ok\n", __func__ );
				err = D_BMA150_RET_OK;
			}
		}
		break;

	default:
		break;
	}

	return err;
}

static const struct file_operations bma150_fops = {
	.owner = THIS_MODULE,
	.read = bma150_read,
	.write = bma150_write,
	.open = bma150_open,
	.release = bma150_close,
	.ioctl = bma150_ioctl,
};




static struct miscdevice bma_device = {
	.minor = MISC_DYNAMIC_MINOR,
	.name = "bma150",
	.fops = &bma150_fops,
};


static void bma150_init_image_register( void )
{
	int ret = 0;

	DEBUG_PRINT( "%s: start.\n", __func__ );

	
	ret = smb380_set_bandwidth( SMB380_BW_50HZ );
	if( ret != 0 )
	{
		printk( KERN_ERR "%s: set bandwidth error\n", __func__ );
	}

	
	ret = smb380_set_range( SMB380_RANGE_8G );
	if( ret != 0 )
	{
		printk( KERN_ERR "%s: set range error\n", __func__ );
	}
	else
	{
		spin_lock( &g_accel_data_spin_lock );
		g_range = SMB380_RANGE_8G;
		spin_unlock( &g_accel_data_spin_lock );
		DEBUG_PRINT( "%s: range(%02X) set\n", __func__, g_range );
	}

	
	ret = smb380_set_mode( SMB380_MODE_SLEEP );
	if( ret != 0 )
	{
		printk( KERN_ERR "%s: set sleep error\n", __func__ );
	}

	DEBUG_PRINT( "%s: end.\n", __func__ );

	return;
}

static void bma150_cycle_sleep( unsigned long setting_sleep_time, struct timeval start_time, struct timeval end_time )
{
	unsigned long diff_sec_time  = 0;
	unsigned long diff_usec_time = 0;
	unsigned long pass_time      = 0;

	
	start_time.tv_sec &= 0xFFFF;
	end_time.tv_sec &= 0xFFFF;

	
	if( end_time.tv_sec < start_time.tv_sec )
	{
		diff_sec_time = end_time.tv_sec + (0xFFFF - start_time.tv_sec + 1);
	}
	else
	{
		diff_sec_time = end_time.tv_sec - start_time.tv_sec;
	}

	
	if( end_time.tv_usec < start_time.tv_usec )
	{
		diff_usec_time = end_time.tv_usec + (1000000 - start_time.tv_usec);
		diff_sec_time--;
	}
	else
	{
		diff_usec_time = end_time.tv_usec - start_time.tv_usec;
	}

	
	pass_time = (diff_sec_time * 1000) + (diff_usec_time / 1000);

	DEBUG_PRINT2( "%s: setting_sleep_time(%lu), pass_time(%lu)\n", __func__, setting_sleep_time, pass_time );
	if( setting_sleep_time > pass_time )
	{
		msleep( (unsigned int)(setting_sleep_time - pass_time) );
	}

	return;
}


static int bma150_poll_thread( void* param )
{
	smb380acc_t    get_accel_data     = {0, 0, 0};
	int            ret                = 0;
	struct timeval start_time;
	struct timeval end_time;
	unsigned long  setting_sleep_time = 200;

	DEBUG_PRINT( "%s: thread create.\n", __func__ );

    memset( &start_time, 0x00, sizeof(struct timeval) );
    memset( &end_time,   0x00, sizeof(struct timeval) );

	while( 1 )
	{
		
		do_gettimeofday( &start_time );

		
		if( g_open_count <= 0 )
		{
			g_is_wait_after_sleep = D_BMA150_WAIT_AFTER_SLEEP_NG;

			
			smb380_set_mode( SMB380_MODE_SLEEP );

			spin_lock( &g_accel_data_spin_lock );
			g_is_ready_accel_data = D_BMA150_ACCEL_DATA_NOT_READY;
			spin_unlock( &g_accel_data_spin_lock );

			DEBUG_PRINT( "%s: stop poll_thread.\n", __func__ );

			
			wait_event( g_open_count_queue, g_open_count > 0 );

			DEBUG_PRINT( "%s: start poll_thread.\n", __func__ );

			
			smb380_set_mode( SMB380_MODE_NORMAL );

			msleep( D_BMA150_STATE_CHANGE_WAIT_MS );

			g_is_wait_after_sleep = D_BMA150_WAIT_AFTER_SLEEP_OK;
			
			wake_up( &g_wait_after_sleep_queue );

			DEBUG_PRINT( "%s: wait end poll_thread.\n", __func__ );
		}

		
		if( g_diag_mode == D_BMA150_DIAG_MODE_ON )
		{
			spin_lock( &g_accel_data_spin_lock );
			g_is_diag_set = D_BMA150_DIAG_SET_TRUE;
			spin_unlock( &g_accel_data_spin_lock );

			
			wake_up( &g_diag_set_queue );

			DEBUG_PRINT( "%s: stop poll_thread. change diag mode DIAG_MODE_ON\n", __func__ );

			
			wait_event( g_diag_mode_queue, g_diag_mode == D_BMA150_DIAG_MODE_OFF );

			spin_lock( &g_accel_data_spin_lock );
			g_is_diag_set = D_BMA150_DIAG_SET_FALSE;
			spin_unlock( &g_accel_data_spin_lock );

			DEBUG_PRINT( "%s: start poll_thread. change diag mode DIAG_MODE_OFF\n", __func__ );

			continue;
		}

		ret = smb380_read_accel_xyz( &get_accel_data );
		if( ret < 0 )
		{
			printk( KERN_ERR "%s: read_accel_xyz error\n", __func__ );
		}
		else
		{
			spin_lock( &g_accel_data_spin_lock );
			memcpy( &g_accel_data, &get_accel_data, sizeof(smb380acc_t) );
			g_is_ready_accel_data = D_BMA150_ACCEL_DATA_READY;
			spin_unlock( &g_accel_data_spin_lock );

			DEBUG_PRINT2( "%s: read_accel_xyz x(%d), y(%d), z(%d)\n", __func__, get_accel_data.x, get_accel_data.y, get_accel_data.z );
		}

		spin_lock( &g_accel_data_spin_lock );
		setting_sleep_time = g_measurement_cycle;
		spin_unlock( &g_accel_data_spin_lock );

		
		do_gettimeofday( &end_time );

		
		bma150_cycle_sleep( setting_sleep_time, start_time, end_time );
	}

	return 0;
}

static int bma150_probe(struct i2c_client *client,
			 const struct i2c_device_id *id)
{
	struct bma150_data *data;
	int err = 0;
	int tempvalue;
	struct task_struct *th;

	DEBUG_PRINT( "%s\n",__FUNCTION__ );

	if (!i2c_check_functionality(client->adapter, I2C_FUNC_I2C))
	{
		printk(KERN_ERR "i2c_check_functionality error\n");
		goto exit;
	}

	

	if (!(data = kmalloc(sizeof(struct bma150_data), GFP_KERNEL)))
	{
		err = -ENOMEM;
		printk(KERN_ERR "kmalloc error\n");
		goto exit;
	}
	memset(data, 0, sizeof(struct bma150_data));

	i2c_set_clientdata(client, data);

	
	mdelay( D_BMA150_AFTER_RESET_WAIT_MS );
	udelay( D_BMA150_AFTER_RESET_WAIT_US );
		
	
	tempvalue = 0;



	i2c_master_send(client, (char*)&tempvalue, 1);
	i2c_master_recv(client, (char*)&tempvalue, 1);

	if((tempvalue&0x00FF) == 0x0002)
	{
		printk(KERN_INFO "Bosch Sensortec Device detected!\nBMA150/SMB380 registered I2C driver!\n");
		bma150_client = client;
	}
	else
	{
		printk(KERN_ERR "Bosch Sensortec Device not found, i2c error %d \n", tempvalue);



		bma150_client = NULL;
		err = -1;
		goto exit_kfree;
	}
	
	
	err = misc_register(&bma_device);
	if (err) {
		printk(KERN_ERR "bma150 device register failed\n");
		goto exit_kfree;
	}
	printk(KERN_INFO "bma150 device create ok\n");

	data->smb380.bus_write = bma150_i2c_write;
	data->smb380.bus_read = bma150_i2c_read;
	data->smb380.delay_msec = bma150_i2c_delay;
	smb380_init(&(data->smb380));
	
	bma150_init_image_register();
	
	
	th = kthread_create( bma150_poll_thread, NULL, "bma150_poll" );
	
	if( IS_ERR(th) )
	{
		misc_deregister( &bma_device );
		
		printk( KERN_ERR "%s: Can't create thread\n", __func__ );
		goto exit_kfree;
	}
	else
	{
		wake_up_process( th );
	}

	return 0;
exit_kfree:
	kfree(data);
exit:
	return err;
}


static int bma150_remove(struct i2c_client *client)
{
	struct bma150_data *data;

	DEBUG_PRINT( "%s\n",__FUNCTION__ );

	data = i2c_get_clientdata(client);
	bma150_client = NULL;
	misc_deregister(&bma_device);
	kfree(data);
	return 0;
}


static const struct i2c_device_id bma150_id[] = {
	{ "bma150", 0 },
	{ }
};

MODULE_DEVICE_TABLE(i2c, bma150_id);

static struct i2c_driver bma150_driver = {	
	.driver = {
		.owner	= THIS_MODULE,	
		.name	= "bma150",
	},
	.class		= I2C_CLASS_HWMON,
	.id_table	= bma150_id,
	.probe		= bma150_probe,
	.remove		= bma150_remove,
};

static int __init BMA150_init(void)
{
	DEBUG_PRINT( "%s\n",__FUNCTION__ );
	spin_lock_init( &g_accel_data_spin_lock );
	init_waitqueue_head( &g_open_count_queue );
	init_waitqueue_head( &g_wait_after_sleep_queue );
	init_waitqueue_head( &g_diag_mode_queue );
	init_waitqueue_head( &g_diag_set_queue );

	return i2c_add_driver(&bma150_driver);
}

static void __exit BMA150_exit(void)
{
	i2c_del_driver(&bma150_driver);
	printk(KERN_ERR "BMA150 exit\n");
}


MODULE_DESCRIPTION("BMA150 driver");

module_init(BMA150_init);
module_exit(BMA150_exit);

