/* Copyright (c) 2009-2010, Code Aurora Forum. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *
 */

/**********************************************************************
* Modified by
* (C) NEC CASIO Mobile Communications, Ltd. 2011
**********************************************************************/






















#ifndef CAMCMP_CMDMAKER_MT9E311_H
#define CAMCMP_CMDMAKER_MT9E311_H

#include <linux/types.h>
#include "camcmp_cmdmaker.h"
#include "camcmp_read_regfile.h"








typedef enum {
	CAMCMP_REG_WRITE = 0,		
	CAMCMP_REG_BINARY,			
	CAMCMP_REG_OR,				
	CAMCMP_REG_AND,				
	CAMCMP_REG_PLUS,			
	CAMCMP_REG_READ,			
	CAMCMP_REG_WAIT,			
	CAMCMP_REG_POLL1,			
	CAMCMP_REG_POLL2,			
	CAMCMP_REG_POLL3,			
	CAMCMP_REG_POLL4,			
	CAMCMP_REG_POLL5,			

	CAMCMP_REG_MASK_WRITE,       

	CAMCMP_REG_WRITE_FW_NOINV,		
	CAMCMP_REG_BINARY_FW_NOINV,		
	CAMCMP_REG_WRITE_FW_INV,		
	CAMCMP_REG_BINARY_FW_INV,		
	CAMCMP_REG_DUMMY			
} camcmp_cmd_kind_enum;




typedef enum {
	CAMCMP_D_LEN_BYTE  = 1,		
	CAMCMP_D_LEN_WORD  = 2,		
	CAMCMP_D_LEN_LWORD = 4		
} camcmp_data_len_enum;































typedef struct {
	camcmp_cmd_kind_enum	cmd_kind;		
	unsigned short			waddr;			
	unsigned int			lwdata;			
	unsigned short*			p_data;			
	unsigned short			size;			
} camcmp_mt9e311_reg_val_type;




typedef struct {
	void*					p_copy;			
	unsigned int			org_val;		
	unsigned short			size;			
} camcmp_mt9e311_blank_val_type;





















void camcmp_mt9e311_get_info(camcmp_cmdmaker_func_type* p_func);




#endif 
