/* Copyright (c) 2009-2010, Code Aurora Forum. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *
 */

/**********************************************************************
* Modified by
* (C) NEC CASIO Mobile Communications, Ltd. 2011
**********************************************************************/

































































#ifndef CAMCMP_CMDSENDER_H
#define CAMCMP_CMDSENDER_H




#include <linux/types.h>
#include <linux/kernel.h>


#include <media/camera_function.h>











#define CAMCMP_LOG_ENABLE



#define CAMCOMBINE2(a,b) a##b
#define CAMCOMBINE3(a,b,c) a##b##c




#define CAMCMP_LOG_DBG(fmt, args...) printk(KERN_INFO "msm_camera:%s(%d) " fmt, __func__, __LINE__, ##args)


#define CAMCMP_LOG_INF(fmt, args...) do { } while (0)














#define CAMCMP_LOG_ERR(fmt, args...) pr_err("msm_camera:%s(%d) " fmt, __func__, __LINE__, ##args)




#define ALARM_LOG(fmt, args...) printk("[T][ARM]" fmt, ##args)
#define ALARM_EVENT_CAMERA  0x60
#define ALARM_EVENT_CAM_FW_DOWN_ERR  0x43
#define ALARM_INFO_CAMERA   0x10







#define CAMCMP_CALC_10000		10000	 
#define CAMCMP_CALC_1000		1000	
#define CAMCMP_CALC_100			100		
#define CAMCMP_CALC_10			10		
#define CAMCMP_CALC_ROUND_OFF	5		
























typedef enum {






































































































































































	
	CAMCMP_CID_CHK_DEV_ID,			
	CAMCMP_CID_BASIC_INIT_HP,		
	CAMCMP_CID_BASIC_INIT_HP_R2,	
	CAMCMP_CID_PATCH_HP,			
	CAMCMP_CID_PATCH_HP_R2,			
	CAMCMP_CID_SCRATCHPAD_HP,		
	CAMCMP_CID_SCRATCHPAD_HP_R2,	
	CAMCMP_CID_SYS_START_GO,		
	CAMCMP_CID_SYS_START_GO_R2,		
	CAMCMP_CID_PATCH_LP,			
	CAMCMP_CID_PATCH_LP_R2,			
	CAMCMP_CID_SCRATCHPAD_LP,		
	CAMCMP_CID_SCRATCHPAD_LP_R2,	
	CAMCMP_CID_SCRATCHPAD_CALIB,	
	CAMCMP_CID_SCRATCHPAD_CALIB_R2,	
	CAMCMP_CID_BASIC_INIT_LP,		
	CAMCMP_CID_BASIC_INIT_LP_R2,	
	CAMCMP_CID_BASIC_INIT_CALIB,	
	CAMCMP_CID_BASIC_INIT_CALIB_R2,	
	CAMCMP_CID_CAP_SIZE,			
	CAMCMP_CID_MONI_SIZE,			
	CAMCMP_CID_CAPTURE_MODE,		
	CAMCMP_CID_PREVIEW_MODE,		
	CAMCMP_CID_MOVIE_MODE,			
	CAMCMP_CID_EFFECT,				
	CAMCMP_CID_AF_MODE,				
	CAMCMP_CID_MF_START,			
	CAMCMP_CID_ANTISHAKE,			 
	CAMCMP_CID_FACE_MODE,			
	CAMCMP_CID_SENSOR_TEST_PATTERN,	 
	CAMCMP_CID_ISP_TEST_PATTERN,	 
	CAMCMP_CID_PREVIEW_SENSOR_MODE,	 
	CAMCMP_CID_CTRL_GAIN,			 
	CAMCMP_CID_BRIGHTNESS,			
	CAMCMP_CID_FORMAT_CHG,			
	CAMCMP_CID_CAP_SIZE_YUV,		
	CAMCMP_CID_SET_AE_AUTO,			 
	CAMCMP_CID_SET_AE_MANUAL,		 
	CAMCMP_CID_ZOOM_8M,				 
	CAMCMP_CID_ZOOM_6MW,			
	CAMCMP_CID_ZOOM_5M,				
	CAMCMP_CID_ZOOM_3M,				
	CAMCMP_CID_ZOOM_2M,				
	CAMCMP_CID_ZOOM_1M,				
	CAMCMP_CID_ZOOM_WVGA,			
	CAMCMP_CID_ZOOM_VGA,			
	CAMCMP_CID_ZOOM_QVGA,			 

	CAMCMP_CID_ZOOM_HD_MOVIE,		
	CAMCMP_CID_ZOOM_VGA_MOVIE,		
	CAMCMP_CID_ZOOM_QVGA_MOVIE,		
	CAMCMP_CID_ZOOM_QCIF_MOVIE,		




	CAMCMP_CID_ANTIBANDING,			
	CAMCMP_CID_SET_BESTSHOT,		 

    CAMCMP_CID_SET_WDR,
    CAMCMP_CID_ISO,
    CAMCMP_CID_SET_PREVCTL,
    CAMCMP_CID_SET_SNAPCTL,
	CAMCMP_CID_SET_SCENE_TEMP,
	CAMCMP_CID_SET_SCENE_BV,
	CAMCMP_CID_SET_BEACH_MIN_TEMP,
	CAMCMP_CID_SET_BEACH_MAX_TEMP,
	CAMCMP_CID_SET_AWB_TEMP_OFF,
	CAMCMP_CID_SET_SCENE_SHARPEN_1,
	CAMCMP_CID_SET_SCENE_DENOISE_1,
	CAMCMP_CID_SET_SCENE_CONTRAST_1,
	CAMCMP_CID_SET_SCENE_SATURATION_1,
	CAMCMP_CID_SET_SCENE_BV_OFF_4,
	CAMCMP_CID_SET_SCENE_SHARPEN_4,
	CAMCMP_CID_SET_SCENE_SATURATION_4,
	CAMCMP_CID_SET_SCENE_CONTRAST_4,
	CAMCMP_CID_SET_SCENE_MACRO_AF_POS,
	CAMCMP_CID_SET_AF_MODE_SETTING,
	CAMCMP_CID_SET_SCENE_PORTRAIT_BV,
	CAMCMP_CID_SET_SCENE_TEMP_OFF_1,
	CAMCMP_CID_SET_SCENE_BV_OFFSET_1,
	CAMCMP_CID_SET_SCENE_ISO,
	CAMCMP_CID_SET_SCENE_LANDSCAPE_MIN_TEMP,
	CAMCMP_CID_SET_SCENE_LANDSCAPE_MAX_TEMP,
	CAMCMP_CID_SET_SCENE_LANDSCAPE_AF_POS_BOUND,
	CAMCMP_CID_SET_SCENE_SHAPEN_2,
	CAMCMP_CID_SET_SCENE_DENOISE_2,
	CAMCMP_CID_SET_SCENE_SATURATION_2,
	CAMCMP_CID_SET_SCENE_CONTRAST_2,
	CAMCMP_CID_SET_SCENE_TEMP_OFF_2,
	CAMCMP_CID_SET_SCENE_BV_OFFSET_2,
	CAMCMP_CID_SET_SCENE_ISO_2,
	CAMCMP_CID_SET_SCENE_DENOISE_4,
	CAMCMP_CID_SET_SCENE_TEMP_OFF_4,
	CAMCMP_CID_SET_SCENE_BV_OFFSET_4,
	CAMCMP_CID_SET_SCENE_ISO_4,
	CAMCMP_CID_SET_SCENE_NIGHT_MAX_EXP_TIME,
	CAMCMP_CID_SET_SCENE_NIGHT_MIN_TEMP,
	CAMCMP_CID_SET_SCENE_NIGHT_MAX_TEMP,
	CAMCMP_CID_SET_SCENE_NIGHT_AF_POS_BOUND,
	CAMCMP_CID_SET_SCENE_SHAPEN_5,
	CAMCMP_CID_SET_SCENE_DENOISE_5,
	CAMCMP_CID_SET_SCENE_SATURATION_5,
	CAMCMP_CID_SET_SCENE_CONTRAST_5,
	CAMCMP_CID_SET_SCENE_TEMP_OFF_5,
	CAMCMP_CID_SET_SCENE_BV_OFFSET_5,
	CAMCMP_CID_SET_SCENE_ISO_5,
	CAMCMP_CID_SET_AE_UPPER_ET,
	CAMCMP_CID_SET_AE_MAX_ET,
	CAMCMP_CID_SET_SCENE_SHARPEN_12,
	CAMCMP_CID_SET_SCENE_DENOISE_12,
	CAMCMP_CID_SET_SCENE_SATURATION_12,
	CAMCMP_CID_SET_SCENE_CONTRAST_12,
	CAMCMP_CID_SET_SCENE_TEMP_OFF_12,
	CAMCMP_CID_SET_SCENE_BV_OFF_12,
	CAMCMP_CID_SET_SCENE_ISO_12,
	CAMCMP_CID_SET_SNAPSHOT_AE_USG,
	CAMCMP_CID_SET_SCENE_SPORT_AF_POS_BOUND,
	CAMCMP_CID_SET_SCENE_SHARPEN_3,
	CAMCMP_CID_SET_SCENE_DENOISE_3,
	CAMCMP_CID_SET_SCENE_SATURATION_3,
	CAMCMP_CID_SET_SCENE_CONTRAST_3,
	CAMCMP_CID_SET_SCENE_TEMP_OFF_3,
	CAMCMP_CID_SET_SCENE_BV_OFF_3,
	CAMCMP_CID_SET_SCENE_ISO_3,
	CAMCMP_CID_SET_AE_BV_MIN,
	CAMCMP_CID_SET_ATM_GAIN,
	CAMCMP_CID_SET_ATM_PPM,
	CAMCMP_CID_SET_AE_BACKLIGHT,
    CAMCMP_CID_SET_ATM_SC_GSHIFT,
    CAMCMP_CID_SET_SCENE_DENOISE_7,
 
	CAMCMP_CID_SET_WHITEBLANCE,		 
	CAMCMP_CID_AF_SEARCH_INF,		
	CAMCMP_CID_AF_SEARCH_MAC,		
	CAMCMP_CID_AF_S1_S2_SET,		
	CAMCMP_CID_AF_S1_S2_STOP,		
	CAMCMP_CID_AF_S1_ENABLE,		
	CAMCMP_CID_AF_IQ_S2_CTRL_LEN,	
	CAMCMP_CID_AF_WINDOW_SET,		
	CAMCMP_CID_AF_WINDOW_MOVIE_SET,	
	CAMCMP_CID_AF_SET_EVAL,			
	CAMCMP_CID_AF_SET_EVAL_R2,		
	CAMCMP_CID_MOVIE_FPS,			
	CAMCMP_CID_SET_REGREAD_SRC,		
	CAMCMP_CID_SET_REGREAD_DST,		
	CAMCMP_CID_SET_REGREAD_SIZE,	
	CAMCMP_CID_SET_REGREAD_CTRL,	

	CAMCMP_CID_SET_REGWRITE_SRC,	
	CAMCMP_CID_SET_REGWRITE_DST,	
	CAMCMP_CID_SET_REGWRITE_SIZE,	
	CAMCMP_CID_SET_REGWRITE_CTRL,	
	CAMCMP_CID_SET_FACE_CTRL,		

	
	CAMCMP_CID_GET_I2C_ADDR,		
	CAMCMP_CID_GET_LOAD_P_ADDR,		
	CAMCMP_CID_GET_PATCH_LP_ADDR,	
	CAMCMP_CID_GET_LENSPOS,			
	CAMCMP_CID_GET_ISP_ID,			 
	CAMCMP_CID_GET_AE_GAIN,			
	CAMCMP_CID_GET_AE_EXP_TIME,		
	CAMCMP_CID_GET_AF_STATE,		
	CAMCMP_CID_GET_EVALUATE,		
	CAMCMP_CID_GET_EVALUATE_R2,		
	CAMCMP_CID_GET_CHIP_VERSION,	
	CAMCMP_CID_GET_XML_VERSION,		
	CAMCMP_CID_GET_SCENE_MODE,		

    CAMCMP_CID_GET_WDR,
    CAMCMP_CID_GET_ISO,
    CAMCMP_CID_GET_ANTISHAKE_CTRL,
    CAMCMP_CID_GET_BESTSHOT_SETTING,
    CAMCMP_CID_GET_WHITEBALANCE,
    CAMCMP_CID_GET_PREVCTL,


	CAMCMP_CID_GET_DEV_ID,
	CAMCMP_CID_GET_MAN_ID,
	CAMCMP_CID_GET_CURRENT_ID,
	CAMCMP_CID_GET_CALIB_RG,
	CAMCMP_CID_GET_CALIB_BG,
	CAMCMP_CID_GET_AFINF_POS,
	CAMCMP_CID_GET_MACRO_POS,
	CAMCMP_CID_GET_FD_FREQ,
	CAMCMP_CID_GET_ANTISHAKE,
	CAMCMP_CID_GET_SNR,
	CAMCMP_CID_GET_DENOISE_VAL,
	CAMCMP_CID_GET_SHARPEN_VAL,
	CAMCMP_CID_GET_AE_BV,
	CAMCMP_CID_GET_AE_TV,
	CAMCMP_CID_GET_AE_GV,
	CAMCMP_CID_GET_AE_DV,
	CAMCMP_CID_GET_AWB_TEMP,
	CAMCMP_CID_GET_AWB_GGAIN,
	CAMCMP_CID_GET_AWB_TEMPOFF,
	CAMCMP_CID_GET_AWB_GGAINOFF,
	CAMCMP_CID_GET_AWB_SATURATION,
	CAMCMP_CID_GET_AWB_SPEED,
	CAMCMP_CID_GET_AWB_MIN_TEMP,
	CAMCMP_CID_GET_AWB_MAX_TEMP,

	CAMCMP_CID_GET_AF_S1_S2_STATE,		
	CAMCMP_CID_GET_AF_S1_CTRL_ENABLE,	
	CAMCMP_CID_GET_FACE_CTRL,			
	CAMCMP_CID_GET_FACE_POS,			
	CAMCMP_CID_GET_SYS_REVISION,		
	CAMCMP_CID_GET_REGREAD_VALUE,		

	CAMCMP_CID_GET_ISO_SPEED,			


	
	CAMCMP_CID_POLL_FACE_CTRL,			
	CAMCMP_CID_POLL_LOAD_OTP,			
 







	
	CAMCMP_CID_MAX					












































































} camcmp_cmd_id_enum;




typedef enum {



	CAMCMP_BID_CAP_SIZE_8M,			 
	CAMCMP_BID_CAP_SIZE_6MW,		 
	CAMCMP_BID_CAP_SIZE_5M,			
	CAMCMP_BID_CAP_SIZE_3M,			
	CAMCMP_BID_CAP_SIZE_2M,			
	CAMCMP_BID_CAP_SIZE_1M,			
	CAMCMP_BID_CAP_SIZE_WVGA,		 
	CAMCMP_BID_CAP_SIZE_VGA,		 
	CAMCMP_BID_CAP_SIZE_QVGA		 





















} camcmp_blank_cap_size_enum;





typedef enum {
	CAMCMP_BID_CAP_SIZE_8M_YUV,		
	CAMCMP_BID_CAP_SIZE_6MW_YUV,	
	CAMCMP_BID_CAP_SIZE_5M_YUV,		
	CAMCMP_BID_CAP_SIZE_3M_YUV,		
	CAMCMP_BID_CAP_SIZE_2M_YUV,		
	CAMCMP_BID_CAP_SIZE_1M_YUV,		
	CAMCMP_BID_CAP_SIZE_WVGA_YUV,	
	CAMCMP_BID_CAP_SIZE_VGA_YUV,	
	CAMCMP_BID_CAP_SIZE_QVGA_YUV	
} camcmp_blank_cap_size_yuv_enum;





typedef enum {



	CAMCMP_BID_MONI_SIZE_HD,		
	CAMCMP_BID_MONI_SIZE_WVGA,		
	CAMCMP_BID_MONI_SIZE_VGA,		
	CAMCMP_BID_MONI_SIZE_QVGA,		
	CAMCMP_BID_MONI_SIZE_QCIF		









































} camcmp_blank_moni_size_enum;




typedef enum {












	CAMCMP_BID_MONI_MODE,
	CAMCMP_BID_MONI_REFRESH,
	CAMCMP_BID_HALF_MODE,
	CAMCMP_BID_CAP_MODE


} camcmp_blank_chg_mode_enum;




typedef enum {


	CAMCMP_BID_ZOOM_0,				
	CAMCMP_BID_ZOOM_1,				
	CAMCMP_BID_ZOOM_2,				
	CAMCMP_BID_ZOOM_3,				
	CAMCMP_BID_ZOOM_4,				
	CAMCMP_BID_ZOOM_5,				
	CAMCMP_BID_ZOOM_6,				
	CAMCMP_BID_ZOOM_7,				
	CAMCMP_BID_ZOOM_8,				
	CAMCMP_BID_ZOOM_9,				























} camcmp_blank_zoom_enum;




typedef enum {

	CAMCMP_BID_BRIGHT_M6,			

	CAMCMP_BID_BRIGHT_M5,			
	CAMCMP_BID_BRIGHT_M4,			
	CAMCMP_BID_BRIGHT_M3,			
	CAMCMP_BID_BRIGHT_M2,			
	CAMCMP_BID_BRIGHT_M1,			
	CAMCMP_BID_BRIGHT_0,			
	CAMCMP_BID_BRIGHT_P1,			
	CAMCMP_BID_BRIGHT_P2,			
	CAMCMP_BID_BRIGHT_P3,			
	CAMCMP_BID_BRIGHT_P4,			
	CAMCMP_BID_BRIGHT_P5,			

	CAMCMP_BID_BRIGHT_P6			

} camcmp_blank_bright_enum;




typedef enum {


	CAMCMP_BID_EFFECT_OFF,			
	CAMCMP_BID_EFFECT_ALIEN,		
	CAMCMP_BID_EFFECT_ANTIQUE,		
	CAMCMP_BID_EFFECT_BLACK_AND_WHITE,	
	CAMCMP_BID_EFFECT_EMBOSS,		
	CAMCMP_BID_EFFECT_EMBOSS_COLORED,	
	CAMCMP_BID_EFFECT_GRAYSCALE,		
	CAMCMP_BID_EFFECT_NEGATIVE,		
	CAMCMP_BID_EFFECT_BLUEISH,		
	CAMCMP_BID_EFFECT_GREENISH,		
	CAMCMP_BID_EFFECT_REDISH,		
	CAMCMP_BID_EFFECT_POSTERIZE1,		
	CAMCMP_BID_EFFECT_POSTERIZE2,		
	CAMCMP_BID_EFFECT_SEPHIA1,		
	CAMCMP_BID_EFFECT_SEPHIA2,		
	CAMCMP_BID_EFFECT_SKETCH,		
	CAMCMP_BID_EFFECT_SOLARIZE,		
	CAMCMP_BID_EFFECT_FOGGY			







} camcmp_blank_effect_enum;




typedef enum {
	CAMCMP_BID_Q_NORMAL,			
	CAMCMP_BID_Q_FINE,				
	CAMCMP_BID_Q_SFINE				
} camcmp_blank_quality_enum;
















typedef enum {
	CAMCMP_BID_MODE_OFF,			 
	CAMCMP_BID_MODE_SAF,			
	CAMCMP_BID_MODE_FACE,			
	CAMCMP_BID_MODE_MF,				

	CAMCMP_BID_MODE_CAF,			
	CAMCMP_BID_MODE_SAF_R2,			
	CAMCMP_BID_MODE_FACE_R2,		
	CAMCMP_BID_MODE_MF_R2,			
	CAMCMP_BID_MODE_CAF_R2			

} camcmp_blank_af_mode_enum;




typedef enum {
	CAMCMP_BID_MF_1M,				
	CAMCMP_BID_MF_MACRO,			
	CAMCMP_BID_MF_INF,				

	CAMCMP_BID_MF_1M_R2,			
	CAMCMP_BID_MF_MACRO_R2,			
	CAMCMP_BID_MF_INF_R2,			

	CAMCMP_BID_MF_0,				
	CAMCMP_BID_MF_CUSTOM			
} camcmp_blank_mf_pos_enum;




typedef enum {
	CAMCMP_BID_JPEG_LIMIT_SIZE_5M,			
	CAMCMP_BID_JPEG_LIMIT_SIZE_3M,			
	CAMCMP_BID_JPEG_LIMIT_SIZE_2M,			
	CAMCMP_BID_JPEG_LIMIT_SIZE_1M			
} camcmp_blank_jpeg_size_enum;







typedef enum {
	CAMCMP_BID_PATCH_HP
} camcmp_blank_patch_hp_enum;




typedef enum {
	CAMCMP_BID_SCRATCHPAD_HP
} camcmp_blank_scratchpad_hp_enum;




typedef enum {
	CAMCMP_BID_SYS_START_GO
} camcmp_blank_sys_start_go_enum;




typedef enum {
	CAMCMP_BID_PATCH_LP
} camcmp_blank_patch_lp_enum;




typedef enum {
	CAMCMP_BID_SCRATCHPAD_LP
} camcmp_blank_scratchpad_lp_enum;




typedef enum {
	CAMCMP_BID_SCRATCHPAD_CALIB
} camcmp_blank_scratchpad_calib_enum;





typedef enum {
	CAMCMP_BID_ANTISHAKE_OFF,			
	CAMCMP_BID_ANTISHAKE_ON,			
} camcmp_blank_antishake_enum;







typedef enum {
	CAMCMP_BID_FACE_MODE_OFF,			
	CAMCMP_BID_FACE_MODE_FACE,			
	CAMCMP_BID_FACE_MODE_FACE_SMILE,	
} camcmp_blank_face_mode_enum;





typedef enum {
	CAMCMP_BID_FACE_CTRL_MANUAL			
} camcmp_blank_face_ctrl_enum;







typedef enum {
	CAMCMP_BID_SENSOR_TEST_PAT_OFF,										
	CAMCMP_BID_SENSOR_TEST_PAT_SOLID_COLOR,						
	CAMCMP_BID_SENSOR_TEST_PAT_COLOR_BAR,							
	CAMCMP_BID_SENSOR_TEST_PAT_FADE_GREY_BAR,					
	CAMCMP_BID_SENSOR_TEST_PAT_PN9_LINK_INTEGRIY_PAT,	
	CAMCMP_BID_SENSOR_TEST_PAT_WALKING_1S_10,					
	CAMCMP_BID_SENSOR_TEST_PAT_WALKING_1S_8						
} camcmp_blank_sensor_test_pat_enum;





typedef enum {
	CAMCMP_BID_ISP_TEST_PAT_SOLID_COLOR_1,				
	CAMCMP_BID_ISP_TEST_PAT_SOLID_COLOR_2,				
	CAMCMP_BID_ISP_TEST_PAT_COLOR_BAR,						
	CAMCMP_BID_ISP_TEST_PAT_FADE_GREY_BAR,				
	CAMCMP_BID_ISP_TEST_PAT_PSEUDO_RANDOM_IMAE1,	
	CAMCMP_BID_ISP_TEST_PAT_PSEUDO_RANDOM_IMAE2,	
	CAMCMP_BID_ISP_TEST_PAT_PSEUDO_RANDOM_IMAE3,	
	CAMCMP_BID_ISP_TEST_PAT_PSEUDO_RANDOM_IMAE4,	
	CAMCMP_BID_ISP_TEST_PAT_VERTICAL_STRIPES,			
	CAMCMP_BID_ISP_TEST_PAT_VERTICAL_RAMP,				
	CAMCMP_BID_ISP_TEST_PAT_WALKING_1S_10,				
	CAMCMP_BID_ISP_TEST_PAT_WALKING_1S_8,					
	CAMCMP_BID_ISP_TEST_PAT_BLACK_WHITE,					
	CAMCMP_BID_ISP_TEST_PAT_OFF										
} camcmp_blank_isp_test_pat_enum;




typedef enum {
	CAMCMP_BID_PREVIEW_SENSOR_MODE_OFF,								
	CAMCMP_BID_PREVIEW_SENSOR_MODE_FULL,							
} camcmp_blank_preview_sensor_mode_enum;




typedef enum {
	CAMCMP_BID_CTRL_GAIN_OFF,			
	CAMCMP_BID_CTRL_GAIN_ON,			
} camcmp_blank_ctrl_gain_enum;






typedef enum {
	CAMCMP_BID_CAP_FORMAT_JPEG,
	CAMCMP_BID_CAP_FORMAT_YUV,
	CAMCMP_BID_CAP_FORMAT_RAW
} camcmp_blank_cap_format_enum;






typedef enum {
	CAMCMP_BID_AE_GAIN,				
	CAMCMP_BID_AE_EXPOSURE,			
} camcmp_blank_ae_manual_enum;






typedef enum {
	CAMCMP_BID_ANTIBANDING_OFF,				
	CAMCMP_BID_ANTIBANDING_50HZ,			
	CAMCMP_BID_ANTIBANDING_60HZ,			
	CAMCMP_BID_ANTIBANDING_AUTO				
} camcmp_blank_antibanding;






typedef enum {
        CAMCMP_BID_SCENE_MODE_NORMAL,                   
        CAMCMP_BID_SCENE_MODE_PORTRAIT,                 
        CAMCMP_BID_SCENE_MODE_LANDSCAPE,                
        CAMCMP_BID_SCENE_MODE_SPORT,                    
        CAMCMP_BID_SCENE_MODE_CLOSEUP,                  
        CAMCMP_BID_SCENE_MODE_NIGHT,                    
        CAMCMP_BID_SCENE_MODE_TWILIGHT,                 
        CAMCMP_BID_SCENE_MODE_BACKLIGHT,                
        CAMCMP_BID_SCENE_MODE_HIGH_SENSITIVE_MODE,      
        CAMCMP_BID_SCENE_MODE_NIGHT_PORTRAIT,           
        CAMCMP_BID_SCENE_MODE_BEACH,                    
        CAMCMP_BID_SCENE_MODE_DOCUMENT,                 
        CAMCMP_BID_SCENE_MODE_PARTY,                    
        CAMCMP_BID_SCENE_MODE_FIREWORKS,                
        CAMCMP_BID_SCENE_MODE_SUNSET                    
} camcmp_blank_bestshot_enum;


#define  CAMCMP_BID_SNAP_CTL_SET	0
#define  CAMCMP_BID_CONTRAST_OFF	0

typedef enum {
        CAMCMP_BID_WDR_OFF,
        CAMCMP_BID_WDR_ON,
} camcmp_blank_wdr_enum;

typedef enum {
        CAMCMP_BID_PREV_CTL_OFF,
        CAMCMP_BID_PREV_CTL_FACE_OFF,
        CAMCMP_BID_PREV_CTL_ON,
} camcmp_blank_prevctl_enum;

typedef enum {
        CAMCMP_BID_AE_MODE_OFF,
        CAMCMP_BID_AE_MODE_ON,
} camcmp_blank_aemode_enum;

typedef enum {
        CAMCMP_BID_AF_MODE_OFF,
        CAMCMP_BID_AF_MODE_ON,
} camcmp_blank_afmode_enum;

typedef enum {
        CAMCMP_BID_AE_UPPER_ET_OFF,
        CAMCMP_BID_AE_UPPER_ET_PARTY,
        CAMCMP_BID_AE_UPPER_ET_SPORT,
        CAMCMP_BID_AE_UPPER_ET_NIGHT,
} camcmp_blank_ae_upper_et_enum;

typedef enum {
        CAMCMP_BID_AE_MAX_ET_OFF,
        CAMCMP_BID_AE_MAX_ET_PARTY,
        CAMCMP_BID_AE_MAX_ET_SPORT,
        CAMCMP_BID_AE_MAX_ET_NIGHT,
} camcmp_blank_ae_max_et_enum;

typedef enum {
        CAMCMP_BID_AE_USG_OFF,
        CAMCMP_BID_AE_USG_SPORT,
} camcmp_blank_ae_usg_enum;

typedef enum {
        CAMCMP_BID_AE_BV_OFF,
        CAMCMP_BID_AE_BV_NIGHT,
        CAMCMP_BID_AE_BV_PARTY,
} camcmp_blank_ae_bv_enum;

typedef enum {
        CAMCMP_BID_ATM_GAIN_OFF,
        CAMCMP_BID_ATM_GAIN_BACKLIGHT,
} camcmp_blank_atm_gain_enum;

typedef enum {
        CAMCMP_BID_ATM_PPM_OFF,
        CAMCMP_BID_ATM_PPM_BACKLIGHT,
} camcmp_blank_atm_ppm_enum;

typedef enum {
        CAMCMP_BID_AE_BKLIGHT_OFF,
        CAMCMP_BID_AE_BKLIGHT_BACKLIGHT,
} camcmp_blank_ae_backlight_enum;

typedef enum {
        CAMCMP_BID_SC_GSHIFT_OFF,
        CAMCMP_BID_SC_GSHIFT_BACKLIGHT,
} camcmp_blank_atm_sc_gshift_enum;

typedef enum {
        CAMCMP_BID_AWE_TEMP_OFF_ZERO,
        CAMCMP_BID_AWE_TEMP_OFF_P100,
        CAMCMP_BID_AWE_TEMP_OFF_M200,
} camcmp_blank_awb_temp_off_enum;

typedef enum {
        CAMCMP_BID_SCENE_SHARPEN_1_OFF,
        CAMCMP_BID_SCENE_SHARPEN_1_PORTRAIT,
} camcmp_blank_scene_sharpen_1_enum;

typedef enum {
        CAMCMP_BID_SCENE_DENOISE_1_OFF,
        CAMCMP_BID_SCENE_DENOISE_1_PORTRAIT,
} camcmp_blank_scene_denoise_1_enum;

typedef enum {
        CAMCMP_BID_SCENE_SATURATION_1_OFF,
        CAMCMP_BID_SCENE_SATURATION_1_PORTRAIT,
} camcmp_blank_scene_saturation_1_enum;

typedef enum {
        CAMCMP_BID_SCENE_BV_4_OFF,
        CAMCMP_BID_SCENE_BV_4_FOOD,
} camcmp_blank_scene_bv_off_4_enum;

typedef enum {
        CAMCMP_BID_SCENE_SHARPEN_4_OFF,
        CAMCMP_BID_SCENE_SHARPEN_4_FOOD,
} camcmp_blank_scene_sharpen_4_enum;

typedef enum {
        CAMCMP_BID_SCENE_SATURATION_4_OFF,
        CAMCMP_BID_SCENE_SATURATION_4_FOOD,
} camcmp_blank_scene_saturation_4_enum;

typedef enum {
        CAMCMP_BID_SCENE_CONTRAST_4_OFF,
        CAMCMP_BID_SCENE_CONTRAST_4_FOOD,
} camcmp_blank_scene_contrast_4_enum;

typedef enum {
        CAMCMP_BID_SCENE_MACRO_AF_OFF,
        CAMCMP_BID_SCENE_MACRO_AF_FOOD,
} camcmp_blank_scene_macro_af_pos_enum;






typedef enum {

        CAMCMP_BID_WB_AUTO,                             
        CAMCMP_BID_WB_DAYLIGHT,                         
        CAMCMP_BID_WB_FLUORESCENT_H,                    
        CAMCMP_BID_WB_FLUORESCENT_L,                    
        CAMCMP_BID_WB_INCANDESCENT,                     
        CAMCMP_BID_WB_CLOUDY,                           











} camcmp_blank_whiteblance_enum;





typedef enum {
        CAMCMP_BID_AFS_INF_VAL,
} camcmp_blank_af_search_inf_enum;




typedef enum {
        CAMCMP_BID_AFS_MAC_VAL,
} camcmp_blank_af_search_mac_enum;


typedef enum {
        CAMCMP_BID_AF_S1_CTRL_DISABLE,
        CAMCMP_BID_AF_S1_CTRL_ENABLE,
} camcmp_blank_af_s1_ctrl_en_enum;




































			
			





















































typedef enum {
	CAMCMP_BID_SET_SAF_MODE_FINE,		
	CAMCMP_BID_SET_SAF_MODE_SINGLE,		
	CAMCMP_BID_SET_SAF_MODE_DOUBLE		
} camcmp_blank_set_saf_mode_enum;




typedef enum {
	CAMCMP_BID_DAC_CODE
} camcmp_blank_dac_code_enum;




typedef enum {
	CAMCMP_BID_AWB_AUTO,			
	CAMCMP_BID_AWB_INCAND,			
	CAMCMP_BID_AWB_FLUORE,			
	CAMCMP_BID_AWB_DAYLIGHT,		
	CAMCMP_BID_AWB_CLOUDY,			
	CAMCMP_BID_AWB_ON,				
} camcmp_blank_awb_kind_enum;




typedef enum {
	CAMCMP_BID_AE_ON,				
	CAMCMP_BID_AE_OFF				
} camcmp_blank_ae_kind_enum;




typedef enum {
	CAMCMP_BID_MODE_MONI_AFS,			
	CAMCMP_BID_MODE_MONI_AFC,			
	CAMCMP_BID_MODE_MONI_MF,			
	CAMCMP_BID_MODE_MONI_AF_OFF			
} camcmp_blank_af_mode_moni_enum;



typedef enum {
	CAMCMP_BID_AF_OPD4_HDELAY,
	CAMCMP_BID_AF_OPD4_VDELAY,
	CAMCMP_BID_AF_OPD4_HVALID,
	CAMCMP_BID_AF_OPD4_VVALID
} camcmp_blank_frame_pos_enum;



typedef enum {
	CAMCMP_BID_AF_AREA_LOW_TYPE1,
	CAMCMP_BID_AF_AREA_HIGH_TYPE1
} camcmp_blank_search_area_enum;



typedef enum {
	CAMCMP_BID_SET_AE_SUB,
}camcmp_blank_set_ae_sub_enum;




typedef enum {
	CAMCMP_BID_AE_OPD_HDELAY,
	CAMCMP_BID_AE_OPD_VDELAY,
	CAMCMP_BID_AE_OPD_HVALID,
	CAMCMP_BID_AE_OPD_VVALID,
} camcmp_blank_photometry;




typedef enum {
	CAMCMP_BID_AE_FREE_WEIGHT
} camcmp_blank_free_weight;







typedef enum {
	CAMCMP_BID_BRIGHTNESS_0,		
	CAMCMP_BID_BRIGHTNESS_1,		
	CAMCMP_BID_BRIGHTNESS_2,		
	CAMCMP_BID_BRIGHTNESS_3,		
    CAMCMP_BID_BRIGHTNESS_4,        
	CAMCMP_BID_BRIGHTNESS_5,		
	CAMCMP_BID_BRIGHTNESS_6,		
	CAMCMP_BID_BRIGHTNESS_7,		
	CAMCMP_BID_BRIGHTNESS_8,		
	CAMCMP_BID_BRIGHTNESS_9,		
	CAMCMP_BID_BRIGHTNESS_10,		
	CAMCMP_BID_BRIGHTNESS_11,		
	CAMCMP_BID_BRIGHTNESS_12		
} camcmp_blank_contrast_enum;








typedef enum {
	CAMCMP_BID_ISO_1600,			
	CAMCMP_BID_ISO_3200,			
	CAMCMP_BID_ISO_12800			
} camcmp_blank_iso_enum;




typedef enum {
	CAMCMP_BID_MOVIE_FPS_NML,		
	CAMCMP_BID_MOVIE_FPS_HD			
} camcmp_blank_movie_fps_enum;






typedef enum {
	CAMCMP_BID_REGREAD_SRC_ADDR,		
} camcmp_blank_regread_src;

typedef enum {
	CAMCMP_BID_REGREAD_SIZE_8,		
	CAMCMP_BID_REGREAD_SIZE_16		
} camcmp_blank_regread_size;

typedef enum {
	CAMCMP_BID_REGWRITE_SRC_VAL,		
} camcmp_blank_regwrite_src;

typedef enum {
	CAMCMP_BID_REGWRITE_DST_ADDR,		
} camcmp_blank_regwrite_dst;

typedef enum {
	CAMCMP_BID_REGWRITE_SIZE_8,		
	CAMCMP_BID_REGWRITE_SIZE_16		
} camcmp_blank_regwrite_size;








typedef struct {
	unsigned char*	p_buff;			
	uint32_t		size;			
} camcmp_buff_type;




typedef struct {
	uint32_t		blank_id;		
	void*			p_blank_data;	
} camcmp_blank_info_type;




typedef struct {
	uint32_t					cmd_id;				
	camcmp_blank_info_type*		p_blank_info;		
	uint32_t					blank_num;			
	void*						p_recieve_data;		
	uint32_t					recieve_num;		
} camcmp_cmd_info_type;




typedef struct {
	uint32_t id; 
	void* p_blank_data;
}write_cmd_setting_t;


#define CAMCMP_SIZE_CMD(a)     (sizeof(a)/sizeof(camcmp_cmd_info_type))


#define CAMCMP_SIZE_BLKINF(a)  (sizeof(a)/sizeof(camcmp_blank_info_type))


#define CAMCMP_SIZE_REVINF(a)  (sizeof(a)/sizeof(uint32_t))




















int32_t camcmp_i2c_init(void* p_client);















int32_t camcmp_makecmd_init(void);















void camcmp_makecmd_get_version(uint16_t* p_ver, uint8_t* p_flg);

















int32_t camcmp_makecmd_correction(void* p_val, uint32_t num);
























int32_t camcmp_isp_trans(camcmp_cmd_info_type* p_info, uint32_t num);

#endif 
