/* Copyright (c) 2009-2010, Code Aurora Forum. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *
 */

/**********************************************************************
* Modified by
* (C) NEC CASIO Mobile Communications, Ltd. 2011
**********************************************************************/






















#ifndef CAMCMP_MT9E311_SETTING_H
#define CAMCMP_MT9E311_SETTING_H




#include <linux/types.h>
#include <linux/kernel.h>
#include <media/camera_function.h>



#define CAMCMP_AF_NAME_MAXLEN 50



typedef enum {
	CAMCMP_PAN_NORMAL_REG,			
	CAMCMP_AF_START,				
	CAMCMP_AF_STOP					
} camcmp_sd_read_enum;




int camcmp_mt9e311_sd_read( uint16_t sys_rev );







typedef struct {
    uint32_t mask;
    uint32_t data;
} T_register_setting;




typedef struct {
	char					item_name[CAMCMP_AF_NAME_MAXLEN];	
	unsigned short			val;								
} T_sd_read_setting;


extern T_register_setting g_mt9e311_wb_info[];          
extern T_register_setting g_mt9e311_scene_info[];       
extern T_register_setting g_mt9e311_wdr_info[];         
extern T_register_setting g_mt9e311_prevctl_info[];     
extern T_register_setting g_mt9e311_aemode_info[];      
extern T_register_setting g_mt9e311_afmode_info[];      
extern T_register_setting g_mt9e311_af_mode[];          
extern T_register_setting g_mt9e311_af_ctrl[];          
extern T_register_setting g_mt9e311_s1_ctrl_en[];       
extern T_sd_read_setting g_mt9e311_sd_read[];           
extern T_register_setting g_mt9e311_face_mode[];        
extern T_register_setting g_mt9e311_faced_ctrl[];       

#endif 
