/*
 * This software program is licensed subject to the GNU General Public License
 * (GPL).Version 2,June 1991, available at http://www.fsf.org/copyleft/gpl.html

 * (C) Copyright 2011 Bosch Sensortec GmbH
 * All Rights Reserved
 */

/**********************************************************************
* Modified by
* (C) NEC CASIO Mobile Communications, Ltd. 2011
**********************************************************************/









#ifndef __BMA150_CALIBRATION__
#define __BMA150_CALIBRATION__

#define ORIENT_X				0
#define ORIENT_Y				0
#define ORIENT_Z				1

#define BMA150_CALIBRATION_MAX_TRIES 20
#define NO_ERR					0x00
#define NO_CALIB				0x100
#define CALIB_ERR_MOV 			0x80
#define CALIB_X_AXIS			1
#define CALIB_Y_AXIS			2
#define CALIB_Z_AXIS			4


int bma150_calibrate(smb380acc_t orientation, smb380acc_t *offset);


int bma150_readCalib(smb380acc_t *offset);


int bma150_writeCalib(smb380acc_t *offset,int EEPROM);



int bma150_calibration(smb380acc_t orientation,smb380acc_t *offset, int tries);


int bma150_calc_new_offset(short orientation, short accel, short *offset, short *stepsize, short *min_accel_adapt, short *min_offset, short *min_reached, short *prev_steps, int iteration_counter);


int bma150_read_accel_avg(int num_avg, smb380acc_t *min, smb380acc_t *max, smb380acc_t *avg );


int bma150_verify_min_max(smb380acc_t min, smb380acc_t max, smb380acc_t avg);

#endif 
